package nc.bs.yp.impl;

import java.io.IOException;
import java.io.PrintWriter;
import java.io.StringWriter;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import nc.vo.ct.saledaily.entity.AggCtSaleVO;
import nc.vo.ct.saledaily.entity.CtSaleExecVO;
import nc.vo.org.SalesOrgVO;
import nc.vo.pub.lang.UFDate;
import nc.vo.pub.workflownote.WorkflownoteVO;
import nc.vo.pubapp.pattern.exception.ExceptionUtils;
import nc.yp.dao.IUtilMaintain;
import nc.bs.dao.BaseDAO;
import nc.bs.framework.adaptor.IHttpServletAdaptor;
import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.framework.common.NCLocator;
import nc.bs.framework.server.ISecurityTokenCallback;
import nc.bs.servlet.service.BaseServlet;
import nc.bs.yp.plugin.GetBaseDAOUtil;
import nc.itf.uap.pf.IPFBusiAction;
import nc.itf.ypff.IProCostCalMaintain;
import nc.log.NcLog;
import nc.md.persist.framework.IMDPersistenceQueryService;
import net.sf.json.JSONObject;


/**
 * ۺͬȡЧ
 * @author YY
 */
public class UnvalidateMaintainImpl extends BaseServlet implements IHttpServletAdaptor{

	//Ψһʶ  
	private String vbillcode = "";
	private WorkflownoteVO Workflownote = new WorkflownoteVO();
	private IPFBusiAction ipf = NCLocator.getInstance().lookup(IPFBusiAction.class);
	private IMDPersistenceQueryService service=NCLocator.getInstance().lookup(IMDPersistenceQueryService.class);
	
	@Override
	public void doAction(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
		try {
			String createStr = buildJson(req, resp, this.getClass().getName());
			JSONObject json = JSONObject.fromObject(createStr);
			NcLog.info("ۺͬȡЧJSON:"+json);
			vbillcode = json.getString("vbillcode");
			//processAction(json);
			collect(json);
			resp.getWriter().write(formatRSJsonData("0",vbillcode,"").toString());
		} catch (Exception e) {
			//ǰ˿̨ӡxml
			resp.getWriter().write(formatRSJsonData("1",vbillcode,e.getMessage()).toString());
			StringWriter stringWriter = new StringWriter();
			e.printStackTrace(new PrintWriter(stringWriter));
			//ȡϸϢ
			String msg=stringWriter.getBuffer().toString();
			NcLog.info("ۺͬȡЧ:"+msg);
		}
		
	}
	
	public void collect(JSONObject json) throws Exception{
		//ָpk
		InvocationInfoProxy.getInstance().setGroupId(GetBaseDAOUtil.getGroup(json.getString("groupCode")).getPk_group());
		NCLocator.getInstance().lookup(ISecurityTokenCallback.class).token("NCSystem".getBytes(),"pfxx".getBytes());
		//֯
		SalesOrgVO salesOrgVO = GetBaseDAOUtil.getSalesOrg(json.getString("pk_org"));
		//ΨһʶȡAggVO
		AggCtSaleVO aggCtSaleVO = (AggCtSaleVO) service.queryBillOfNCObjectByPKWithDR(AggCtSaleVO.class,GetBaseDAOUtil.GetVOID("ct_sale",json.getString("vbillcode")),true).getContainmentObject();
		CtSaleExecVO[] ctSaleExecArrVO = new CtSaleExecVO[aggCtSaleVO.getChildren(CtSaleExecVO.class).length+1];
		for (int i = 0; i < aggCtSaleVO.getChildren(CtSaleExecVO.class).length; i++) {
			ctSaleExecArrVO[i] = (CtSaleExecVO) aggCtSaleVO.getChildren(CtSaleExecVO.class)[i];
		}
		CtSaleExecVO  ctSaleExecVO = new CtSaleExecVO();
		//
		ctSaleExecVO.setPk_group(aggCtSaleVO.getParentVO().getPk_group());
		//ԭʼ֯
		ctSaleExecVO.setPk_org(salesOrgVO.getPk_org());
		//֯
		ctSaleExecVO.setPk_org_v(salesOrgVO.getPk_vid());
		//
		ctSaleExecVO.setVexecdate(new UFDate(json.getString("dbilldate")));
		//ִй
		ctSaleExecVO.setVexecflow("ȡЧ");
		//ԭ
		ctSaleExecVO.setVexecreason(json.getString("vexecreason"));
		//vo״̬
		ctSaleExecVO.setStatus(2);
		//ϲ
		ctSaleExecVO.setPk_ct_sale((String) aggCtSaleVO.getParent().getAttributeValue("pk_ct_sale"));
		ctSaleExecArrVO[ctSaleExecArrVO.length-1] = ctSaleExecVO;
		aggCtSaleVO.setChildren(CtSaleExecVO.class, ctSaleExecArrVO);
		//õȡЧű
		ipf.processAction("UNVALIDATE", "Z3", Workflownote, aggCtSaleVO, null, null);
	}
	
	/**
	 * 
	 * ö
	 * @param aggGatheringBillVO
	 * @throws Exception
	 */
	public void processAction(JSONObject json) throws Exception{
		NCLocator.getInstance().lookup(ISecurityTokenCallback.class).token("NCSystem".getBytes(),"pfxx".getBytes());
		IUtilMaintain iUtilMaintain =  NCLocator.getInstance().lookup(IUtilMaintain.class);
		iUtilMaintain.XSHTQX_RequiresNew(json);
	}

}
